
/*
** ivt reads the fileformat used by InfoViewer in MSVC
*/

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "support.h"
#include "ivt.h"

/* the main program */
int main(int argc, char **argv) {
    FILE *ivt = fopen(argv[1],"r");
    ivthdr header;
    globalivtidx index;
    mszpentry *chain=NULL,*t;

    if(!ivt) 
	{
        fprintf(stderr,"couldn't open a file for input.\n");
        return 1;
    }

	wvGetivthdr(ivt,&header);

    if(header.Magic!=IVTHEADER) 
	{
        fprintf(stderr,"not a ivt file\n");
        return 1;
    }

    printf("Seeking %X...\n",header.DirectoryStart);
    fseek(ivt,header.DirectoryStart,SEEK_SET);
	wvGetglobalivtidx(ivt,&index);

    if(index.magic == IVTINDEX)
        printf("Success...\n");
    else 
	{
        fprintf(stderr,"Bad maths. %X != %X\n",index.magic, IVTINDEX);
        exit(1);
    }

    wvGetmszpentryChain(ivt,&chain,&index);

    /* process the files */
    for(t = chain; t; t=t->next) 
        wvDumpFile(ivt,t);

	wvReleasemszpentryChain(&chain);
    fclose(ivt);
	return(0);
}
